Index: uspace/lib/c/include/unistd.h
===================================================================
--- uspace/lib/c/include/unistd.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/include/unistd.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -41,5 +41,5 @@
 
 #ifndef NULL
-	#define NULL	((void *) 0)
+	#define NULL  0UL
 #endif
 
Index: uspace/lib/net/adt/module_map.c
===================================================================
--- uspace/lib/net/adt/module_map.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/adt/module_map.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -59,16 +59,16 @@
  *			running.
  * @param[in] connect_module The module connecting function.
- * @return		EOK on success.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 int
-add_module(module_t **module, modules_t *modules, const char *name,
+add_module(module_ref *module, modules_ref modules, const char *name,
     const char *filename, services_t service, task_id_t task_id,
     connect_module_t connect_module)
 {
-	module_t *tmp_module;
+	module_ref tmp_module;
 	int rc;
 
-	tmp_module = (module_t *) malloc(sizeof(module_t));
+	tmp_module = (module_ref) malloc(sizeof(module_t));
 	if (!tmp_module)
 		return ENOMEM;
@@ -100,11 +100,11 @@
  * @param[in] modules	The module map.
  * @param[in] name	The module name.
- * @return		The running module found. It does not have to be
+ * @returns		The running module found. It does not have to be
  *			connected.
- * @return		NULL if there is no such module.
+ * @returns		NULL if there is no such module.
  */
-module_t *get_running_module(modules_t *modules, char *name)
+module_ref get_running_module(modules_ref modules, char *name)
 {
-	module_t *module;
+	module_ref module;
 
 	module = modules_find(modules, name, 0);
@@ -126,6 +126,6 @@
  *
  * @param[in] fname	The module full or relative path filename.
- * @return		The new module task identifier on success.
- * @return		Zero if there is no such module.
+ * @returns		The new module task identifier on success.
+ * @returns		Zero if there is no such module.
  */
 task_id_t spawn(const char *fname)
Index: uspace/lib/net/generic/generic.c
===================================================================
--- uspace/lib/net/generic/generic.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/generic/generic.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -92,13 +92,13 @@
  * @param[out] address	The desired address.
  * @param[out] data	The address data container.
- * @return		EOK on success.
- * @return		EBADMEM if the address parameter and/or the data
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the address parameter and/or the data
  *			parameter is NULL.
- * @return		Other error codes as defined for the specific service
+ * @returns		Other error codes as defined for the specific service
  *			message.
  */
 int
 generic_get_addr_req(int phone, int message, device_id_t device_id,
-    measured_string_t **address, char ** data)
+    measured_string_ref *address, char ** data)
 {
 	aid_t message_id;
@@ -138,5 +138,5 @@
 int
 generic_packet_size_req_remote(int phone, int message, device_id_t device_id,
-    packet_dimension_t *packet_dimension)
+    packet_dimension_ref packet_dimension)
 {
 	if (!packet_dimension)
@@ -223,16 +223,16 @@
  * @param[out] translation The translated values.
  * @param[out] data	The translation data container.
- * @return		EOK on success.
- * @return		EINVAL if the configuration parameter is NULL.
- * @return		EINVAL if the count parameter is zero.
- * @return		EBADMEM if the translation or the data parameters are
+ * @returns		EOK on success.
+ * @returns		EINVAL if the configuration parameter is NULL.
+ * @returns		EINVAL if the count parameter is zero.
+ * @returns		EBADMEM if the translation or the data parameters are
  *			NULL.
- * @return		Other error codes as defined for the specific service
+ * @returns		Other error codes as defined for the specific service
  *			message.
  */
 int
 generic_translate_req(int phone, int message, device_id_t device_id,
-    services_t service, measured_string_t *configuration, size_t count,
-    measured_string_t **translation, char **data)
+    services_t service, measured_string_ref configuration, size_t count,
+    measured_string_ref *translation, char **data)
 {
 	aid_t message_id;
Index: uspace/lib/net/generic/net_checksum.c
===================================================================
--- uspace/lib/net/generic/net_checksum.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/generic/net_checksum.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -48,5 +48,5 @@
  *
  * @param[in] sum	Computed checksum.
- * @return		Compacted computed checksum to the 16 bits.
+ * @returns		Compacted computed checksum to the 16 bits.
  */
 uint16_t compact_checksum(uint32_t sum)
@@ -66,5 +66,5 @@
  * @param[in] data	Pointer to the beginning of data to process.
  * @param[in] length	Length of the data in bytes.
- * @return		The computed checksum of the length bytes of the data.
+ * @returns		The computed checksum of the length bytes of the data.
  */
 uint32_t compute_checksum(uint32_t seed, uint8_t *data, size_t length)
@@ -88,5 +88,5 @@
  * @param[in] data	Pointer to the beginning of data to process.
  * @param[in] length	Length of the data in bits.
- * @return		The computed CRC32 of the length bits of the data.
+ * @returns		The computed CRC32 of the length bits of the data.
  */
 uint32_t compute_crc32_be(uint32_t seed, uint8_t * data, size_t length)
@@ -142,5 +142,5 @@
  * @param[in] data	Pointer to the beginning of data to process.
  * @param[in] length	Length of the data in bits.
- * @return		The computed CRC32 of the length bits of the data.
+ * @returns		The computed CRC32 of the length bits of the data.
  */
 uint32_t compute_crc32_le(uint32_t seed, uint8_t * data, size_t length)
@@ -193,6 +193,6 @@
  *
  * @param[in] checksum	The computed checksum.
- * @return		The internet protocol header checksum.
- * @return		0xFFFF if the computed checksum is zero.
+ * @returns		The internet protocol header checksum.
+ * @returns		0xFFFF if the computed checksum is zero.
  */
 uint16_t flip_checksum(uint16_t checksum)
@@ -211,6 +211,6 @@
  * @param[in] data	The header data.
  * @param[in] length	The header length in bytes.
- * @return		The internet protocol header checksum.
- * @return		0xFFFF if the computed checksum is zero.
+ * @returns		The internet protocol header checksum.
+ * @returns		0xFFFF if the computed checksum is zero.
  */
 uint16_t ip_checksum(uint8_t *data, size_t length)
Index: uspace/lib/net/generic/net_remote.c
===================================================================
--- uspace/lib/net/generic/net_remote.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/generic/net_remote.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -49,5 +49,5 @@
 /** Connects to the networking module.
  *
- * @return		The networking module phone on success.
+ * @returns		The networking module phone on success.
  */
 int net_connect_module(void)
@@ -63,5 +63,5 @@
  * @see net_get_conf_req()
  */
-void net_free_settings(measured_string_t *settings, char *data)
+void net_free_settings(measured_string_ref settings, char *data)
 {
 	if (settings)
@@ -83,12 +83,12 @@
  * @param[in] count	The configuration entries count.
  * @param[in,out] data	The configuration and settings data.
- * @return		EOK on success.
- * @return		EINVAL if the configuration is NULL.
- * @return		EINVAL if the count is zero.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		EINVAL if the configuration is NULL.
+ * @returns		EINVAL if the count is zero.
+ * @returns		Other error codes as defined for the
  *			generic_translate_req() function.
  */
 int
-net_get_conf_req(int net_phone, measured_string_t **configuration,
+net_get_conf_req(int net_phone, measured_string_ref *configuration,
     size_t count, char **data)
 {
@@ -110,13 +110,13 @@
  * @param[in] count	The configuration entries count.
  * @param[in,out] data	The configuration and settings data.
- * @return		EOK on success.
- * @return		EINVAL if the configuration is NULL.
- * @return		EINVAL if the count is zero.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		EINVAL if the configuration is NULL.
+ * @returns		EINVAL if the count is zero.
+ * @returns		Other error codes as defined for the
  *			generic_translate_req() function.
  */
 int
 net_get_device_conf_req(int net_phone, device_id_t device_id,
-    measured_string_t **configuration, size_t count, char **data)
+    measured_string_ref *configuration, size_t count, char **data)
 {
 	return generic_translate_req(net_phone, NET_NET_GET_DEVICE_CONF,
Index: uspace/lib/net/generic/packet_client.c
===================================================================
--- uspace/lib/net/generic/packet_client.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/generic/packet_client.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -53,9 +53,9 @@
  * @param[in] data	The data to be copied.
  * @param[in] length	The length of the copied data.
- * @return		EOK on success.
- * @return		EINVAL if the packet is not valid.
- * @return		ENOMEM if there is not enough memory left.
- */
-int packet_copy_data(packet_t *packet, const void *data, size_t length)
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is not valid.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+int packet_copy_data(packet_t packet, const void *data, size_t length)
 {
 	if (!packet_is_valid(packet))
@@ -78,11 +78,11 @@
  * @param[in] length	The space length to be allocated at the beginning of the
  *			packet content.
- * @return		The pointer to the allocated memory.
- * @return		NULL if there is not enough memory left.
- */
-void *packet_prefix(packet_t *packet, size_t length)
+ * @returns		The pointer to the allocated memory.
+ * @returns		NULL if there is not enough memory left.
+ */
+void *packet_prefix(packet_t packet, size_t length)
 {
 	if ((!packet_is_valid(packet)) ||
-	    (packet->data_start - sizeof(packet_t) -
+	    (packet->data_start - sizeof(struct packet) -
 	    2 * (packet->dest_addr - packet->src_addr) < length)) {
 		return NULL;
@@ -99,8 +99,8 @@
  * @param[in] length	The space length to be allocated at the end of the
  *			 packet content.
- * @return		The pointer to the allocated memory.
- * @return		NULL if there is not enough memory left.
- */
-void *packet_suffix(packet_t *packet, size_t length)
+ * @returns		The pointer to the allocated memory.
+ * @returns		NULL if there is not enough memory left.
+ */
+void *packet_suffix(packet_t packet, size_t length)
 {
 	if ((!packet_is_valid(packet)) ||
@@ -120,9 +120,9 @@
  * @param[in] suffix	The suffix length to be removed from the end of the
  *			packet content.
- * @return		EOK on success.
- * @return		EINVAL if the packet is not valid.
- * @return		ENOMEM if there is not enough memory left.
- */
-int packet_trim(packet_t *packet, size_t prefix, size_t suffix)
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is not valid.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+int packet_trim(packet_t packet, size_t prefix, size_t suffix)
 {
 	if (!packet_is_valid(packet))
@@ -140,8 +140,8 @@
  *
  * @param[in] packet	The packet.
- * @return		The packet identifier.
- * @return		Zero if the packet is not valid.
- */
-packet_id_t packet_get_id(const packet_t *packet)
+ * @returns		The packet identifier.
+ * @returns		Zero if the packet is not valid.
+ */
+packet_id_t packet_get_id(const packet_t packet)
 {
 	return packet_is_valid(packet) ? packet->packet_id : 0;
@@ -153,9 +153,9 @@
  * @param[out] src	The source address. May be NULL if not desired.
  * @param[out] dest	The destination address. May be NULL if not desired.
- * @return		The stored addresses length.
- * @return		Zero if the addresses are not present.
- * @return		EINVAL if the packet is not valid.
- */
-int packet_get_addr(const packet_t *packet, uint8_t **src, uint8_t **dest)
+ * @returns		The stored addresses length.
+ * @returns		Zero if the addresses are not present.
+ * @returns		EINVAL if the packet is not valid.
+ */
+int packet_get_addr(const packet_t packet, uint8_t **src, uint8_t **dest)
 {
 	if (!packet_is_valid(packet))
@@ -174,8 +174,8 @@
  *
  * @param[in] packet	The packet.
- * @return		The packet content length in bytes.
- * @return		Zero if the packet is not valid.
- */
-size_t packet_get_data_length(const packet_t *packet)
+ * @returns		The packet content length in bytes.
+ * @returns		Zero if the packet is not valid.
+ */
+size_t packet_get_data_length(const packet_t packet)
 {
 	if (!packet_is_valid(packet))
@@ -188,8 +188,8 @@
  *
  * @param[in] packet	The packet.
- * @return		The pointer to the beginning of the packet content.
- * @return		NULL if the packet is not valid.
- */
-void *packet_get_data(const packet_t *packet)
+ * @returns		The pointer to the beginning of the packet content.
+ * @returns		NULL if the packet is not valid.
+ */
+void *packet_get_data(const packet_t packet)
 {
 	if (!packet_is_valid(packet))
@@ -205,10 +205,10 @@
  * @param[in] dest	The new destination address. May be NULL.
  * @param[in] addr_len	The addresses length.
- * @return		EOK on success.
- * @return		EINVAL if the packet is not valid.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is not valid.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 int
-packet_set_addr(packet_t *packet, const uint8_t *src, const uint8_t *dest,
+packet_set_addr(packet_t packet, const uint8_t *src, const uint8_t *dest,
     size_t addr_len)
 {
@@ -254,10 +254,10 @@
  * @param[in] phone	The packet server module phone.
  * @param[in] packet	The original packet.
- * @return		The packet copy.
- * @return		NULL on error.
- */
-packet_t *packet_get_copy(int phone, packet_t *packet)
-{
-	packet_t *copy;
+ * @returns		The packet copy.
+ * @returns		NULL on error.
+ */
+packet_t packet_get_copy(int phone, packet_t packet)
+{
+	packet_t copy;
 	uint8_t * src = NULL;
 	uint8_t * dest = NULL;
Index: uspace/lib/net/generic/packet_remote.c
===================================================================
--- uspace/lib/net/generic/packet_remote.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/generic/packet_remote.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -64,5 +64,5 @@
  */
 static int
-packet_return(int phone, packet_t **packet, packet_id_t packet_id, size_t size)
+packet_return(int phone, packet_ref packet, packet_id_t packet_id, size_t size)
 {
 	ipc_call_t answer;
@@ -72,5 +72,5 @@
 	message = async_send_1(phone, NET_PACKET_GET, packet_id, &answer);
 
-	*packet = (packet_t *) as_get_mappable_page(size);
+	*packet = (packet_t) as_get_mappable_page(size);
 	rc = async_share_in_start_0_0(phone, *packet, size);
 	if (rc != EOK) {
@@ -100,12 +100,12 @@
  * @param[out] packet	The packet reference.
  * @param[in] packet_id	The packet identifier.
- * @return		EOK on success.
- * @return		EINVAL if the packet parameter is NULL.
- * @return		Other error codes as defined for the NET_PACKET_GET_SIZE
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet parameter is NULL.
+ * @returns		Other error codes as defined for the NET_PACKET_GET_SIZE
  *			message.
- * @return		Other error codes as defined for the packet_return()
+ * @returns		Other error codes as defined for the packet_return()
  *			function.
  */
-int packet_translate_remote(int phone, packet_t **packet, packet_id_t packet_id)
+int packet_translate_remote(int phone, packet_ref packet, packet_id_t packet_id)
 {
 	int rc;
@@ -127,5 +127,5 @@
 	}
 	if ((*packet)->next) {
-		packet_t *next;
+		packet_t next;
 		
 		return packet_translate_remote(phone, &next, (*packet)->next);
@@ -145,8 +145,8 @@
  * @param[in] max_content The maximal content length in bytes.
  * @param[in] max_suffix The maximal suffix length in bytes.
- * @return		The packet reference.
- * @return		NULL on error.
- */
-packet_t *packet_get_4_remote(int phone, size_t max_content, size_t addr_len,
+ * @returns		The packet reference.
+ * @returns		NULL on error.
+ */
+packet_t packet_get_4_remote(int phone, size_t max_content, size_t addr_len,
     size_t max_prefix, size_t max_suffix)
 {
@@ -161,5 +161,5 @@
 	
 	
-	packet_t *packet = pm_find(packet_id);
+	packet_t packet = pm_find(packet_id);
 	if (!packet) {
 		rc = packet_return(phone, &packet, packet_id, size);
@@ -177,8 +177,8 @@
  * @param[in] phone	The packet server module phone.
  * @param[in] content	The maximal content length in bytes.
- * @return		The packet reference.
- * @return		NULL on error.
- */
-packet_t *packet_get_1_remote(int phone, size_t content)
+ * @returns		The packet reference.
+ * @returns		NULL on error.
+ */
+packet_t packet_get_1_remote(int phone, size_t content)
 {
 	ipcarg_t packet_id;
@@ -191,5 +191,5 @@
 		return NULL;
 	
-	packet_t *packet = pm_find(packet_id);
+	packet_t packet = pm_find(packet_id);
 	if (!packet) {
 		rc = packet_return(phone, &packet, packet_id, size);
Index: uspace/lib/net/generic/protocol_map.c
===================================================================
--- uspace/lib/net/generic/protocol_map.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/generic/protocol_map.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -42,7 +42,7 @@
  * @param[in] nil	Network interface layer service.
  * @param[in] il	Internetwork layer service.
- * @return		Network interface layer type of the internetworking
+ * @returns		Network interface layer type of the internetworking
  *			layer service.
- * @return		Zero if mapping is not found.
+ * @returns		Zero if mapping is not found.
  */
 eth_type_t protocol_map(services_t nil, services_t il)
@@ -68,7 +68,7 @@
  * @param[in] nil	Network interface layer service.
  * @param[in] protocol	Network interface layer type.
- * @return		Internetwork layer service of the network interface
+ * @returns		Internetwork layer service of the network interface
  *			layer type.
- * @return		Zero if mapping is not found.
+ * @returns		Zero if mapping is not found.
  */
 services_t protocol_unmap(services_t nil, int protocol)
@@ -94,7 +94,7 @@
  *
  * @param[in] lsap	Link service access point identifier.
- * @return		Ethernet protocol identifier of the link service access
+ * @returns		Ethernet protocol identifier of the link service access
  *			point identifier.
- * @return		ETH_LSAP_NULL if mapping is not found.
+ * @returns		ETH_LSAP_NULL if mapping is not found.
  */
 eth_type_t lsap_map(eth_lsap_t lsap)
@@ -114,6 +114,6 @@
  *
  * @param[in] ethertype	Ethernet protocol identifier.
- * @return		Link service access point identifier.
- * @return		Zero if mapping is not found.
+ * @returns		Link service access point identifier.
+ * @returns		Zero if mapping is not found.
  */
 eth_lsap_t lsap_unmap(eth_type_t ethertype)
@@ -132,6 +132,6 @@
  *
  * @param[in] nil	The network interface service.
- * @return		The hardware type of the network interface service.
- * @return		Zero if mapping is not found.
+ * @returns		The hardware type of the network interface service.
+ * @returns		Zero if mapping is not found.
  */
 hw_type_t hardware_map(services_t nil)
Index: uspace/lib/net/il/arp_remote.c
===================================================================
--- uspace/lib/net/il/arp_remote.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/il/arp_remote.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -52,5 +52,5 @@
  *
  * @param service	The ARP module service. Ignored parameter.
- * @return		The ARP module phone on success.
+ * @returns		The ARP module phone on success.
  */
 int arp_connect_module(services_t service)
@@ -65,5 +65,5 @@
  *
  * @param[in] arp_phone	The ARP module phone used for (semi)remote calls.
- * @return		EOK on success.
+ * @returns		EOK on success.
  */
 int arp_clean_cache_req(int arp_phone)
@@ -78,10 +78,10 @@
  * @param[in] protocol	The requesting protocol service.
  * @param[in] address	The protocol address to be cleared.
- * @return		EOK on success.
- * @return		ENOENT if the mapping is not found.
+ * @returns		EOK on success.
+ * @returns		ENOENT if the mapping is not found.
  */
 int
 arp_clear_address_req(int arp_phone, device_id_t device_id, services_t protocol,
-    measured_string_t *address)
+    measured_string_ref address)
 {
 	aid_t message_id;
@@ -100,6 +100,6 @@
  * @param[in] arp_phone	The ARP module phone used for (semi)remote calls.
  * @param[in] device_id	The device identifier.
- * @return		EOK on success.
- * @return		ENOENT if the device is not found.
+ * @returns		EOK on success.
+ * @returns		ENOENT if the device is not found.
  */
 int arp_clear_device_req(int arp_phone, device_id_t device_id)
@@ -119,19 +119,19 @@
  * @param[in] netif	The underlying device network interface layer service.
  * @param[in] address	The local requesting protocol address of the device.
- * @return		EOK on success.
- * @return		EEXIST if the device is already used.
- * @return		ENOMEM if there is not enough memory left.
- * @return		ENOENT if the network interface service is not known.
- * @return		EREFUSED if the network interface service is not
+ * @returns		EOK on success.
+ * @returns		EEXIST if the device is already used.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		ENOENT if the network interface service is not known.
+ * @returns		EREFUSED if the network interface service is not
  *			responding.
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the
  *			nil_packet_get_size() function.
- * @return		Other error codes as defined for the nil_get_addr()
+ * @returns		Other error codes as defined for the nil_get_addr()
  *			function.
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the
  *			nil_get_broadcast_addr() function.
  */
 int arp_device_req(int arp_phone, device_id_t device_id, services_t protocol,
-    services_t netif, measured_string_t *address)
+    services_t netif, measured_string_ref address)
 {
 	aid_t message_id;
@@ -157,13 +157,13 @@
  * @param[out] translation The translation of the local protocol address.
  * @param[out] data	The allocated raw translation data container.
- * @return		EOK on success.
- * @return		EINVAL if the address parameter is NULL.
- * @return		EBADMEM if the translation or the data parameters are
+ * @returns		EOK on success.
+ * @returns		EINVAL if the address parameter is NULL.
+ * @returns		EBADMEM if the translation or the data parameters are
  *			NULL.
- * @return		ENOENT if the mapping is not found.
+ * @returns		ENOENT if the mapping is not found.
  */
 int
 arp_translate_req(int arp_phone, device_id_t device_id, services_t protocol,
-    measured_string_t *address, measured_string_t **translation, char **data)
+    measured_string_ref address, measured_string_ref *translation, char **data)
 {
 	return generic_translate_req(arp_phone, NET_ARP_TRANSLATE, device_id,
Index: uspace/lib/net/il/il_interface.c
===================================================================
--- uspace/lib/net/il/il_interface.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/il/il_interface.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -77,5 +77,5 @@
  *
  */
-int il_received_msg(int il_phone, device_id_t device_id, packet_t *packet,
+int il_received_msg(int il_phone, device_id_t device_id, packet_t packet,
     services_t target)
 {
Index: uspace/lib/net/il/ip_client.c
===================================================================
--- uspace/lib/net/il/ip_client.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/il/ip_client.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -48,12 +48,12 @@
  *
  * @param[in] packet	The packet.
- * @return		The IP header length in bytes.
- * @return		Zero if there is no IP header.
- */
-size_t ip_client_header_length(packet_t *packet)
-{
-	ip_header_t *header;
-
-	header = (ip_header_t *) packet_get_data(packet);
+ * @returns		The IP header length in bytes.
+ * @returns		Zero if there is no IP header.
+ */
+size_t ip_client_header_length(packet_t packet)
+{
+	ip_header_ref header;
+
+	header = (ip_header_ref) packet_get_data(packet);
 	if (!header || (packet_get_data_length(packet) < sizeof(ip_header_t)))
 		return 0;
@@ -72,17 +72,17 @@
  * @param[out] header	The constructed IPv4 pseudo header.
  * @param[out] headerlen The length of the IP pseudo header in bytes.
- * @return		EOK on success.
- * @return		EBADMEM if the header and/or the headerlen parameter is
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the header and/or the headerlen parameter is
  *			NULL.
- * @return		EINVAL if the source address and/or the destination
+ * @returns		EINVAL if the source address and/or the destination
  *			address parameter is NULL.
- * @return		EINVAL if the source address length is less than struct
+ * @returns		EINVAL if the source address length is less than struct
  *			sockaddr length.
- * @return		EINVAL if the source address length differs from the
+ * @returns		EINVAL if the source address length differs from the
  *			destination address length.
- * @return		EINVAL if the source address family differs from the
+ * @returns		EINVAL if the source address family differs from the
  *			destination family.
- * @return		EAFNOSUPPORT if the address family is not supported.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EAFNOSUPPORT if the address family is not supported.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 int
@@ -91,5 +91,5 @@
     size_t data_length, void **header, size_t *headerlen)
 {
-	ipv4_pseudo_header_t *header_in;
+	ipv4_pseudo_header_ref header_in;
 	struct sockaddr_in *address_in;
 
@@ -109,5 +109,5 @@
 		
 		*headerlen = sizeof(*header_in);
-		header_in = (ipv4_pseudo_header_t *) malloc(*headerlen);
+		header_in = (ipv4_pseudo_header_ref) malloc(*headerlen);
 		if (!header_in)
 			return ENOMEM;
@@ -148,12 +148,12 @@
  *			disabled.
  * @param[in] ipopt_length The prefixed IP options length in bytes.
- * @return		EOK on success.
- * @return		ENOMEM if there is not enough memory left in the packet.
- */
-int
-ip_client_prepare_packet(packet_t *packet, ip_protocol_t protocol, ip_ttl_t ttl,
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left in the packet.
+ */
+int
+ip_client_prepare_packet(packet_t packet, ip_protocol_t protocol, ip_ttl_t ttl,
     ip_tos_t tos, int dont_fragment, size_t ipopt_length)
 {
-	ip_header_t *header;
+	ip_header_ref header;
 	uint8_t *data;
 	size_t padding;
@@ -177,5 +177,5 @@
 
 	// set the header
-	header = (ip_header_t *) data;
+	header = (ip_header_ref) data;
 	header->header_length = IP_COMPUTE_HEADER_LENGTH(sizeof(ip_header_t) +
 	    ipopt_length);
@@ -203,15 +203,15 @@
  * @param[out] ipopt_length The IP options length in bytes. May be NULL if not
  *			desired.
- * @return		The prefixed IP header length in bytes on success.
- * @return		ENOMEM if the packet is too short to contain the IP
+ * @returns		The prefixed IP header length in bytes on success.
+ * @returns		ENOMEM if the packet is too short to contain the IP
  *			header.
  */
 int
-ip_client_process_packet(packet_t *packet, ip_protocol_t *protocol,
+ip_client_process_packet(packet_t packet, ip_protocol_t *protocol,
     ip_ttl_t *ttl, ip_tos_t *tos, int *dont_fragment, size_t *ipopt_length)
 {
-	ip_header_t *header;
-
-	header = (ip_header_t *) packet_get_data(packet);
+	ip_header_ref header;
+
+	header = (ip_header_ref) packet_get_data(packet);
 	if (!header || (packet_get_data_length(packet) < sizeof(ip_header_t)))
 		return ENOMEM;
@@ -238,7 +238,7 @@
  * @param[in] headerlen	The length of the IP pseudo header in bytes.
  * @param[in] data_length The data length to be set.
- * @return		EOK on success.
- * @return		EBADMEM if the header parameter is NULL.
- * @return		EINVAL if the headerlen parameter is not IPv4 pseudo
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the header parameter is NULL.
+ * @returns		EINVAL if the headerlen parameter is not IPv4 pseudo
  *			header length.
  */
@@ -247,5 +247,5 @@
     size_t data_length)
 {
-	ipv4_pseudo_header_t *header_in;
+	ipv4_pseudo_header_ref header_in;
 
 	if (!header)
@@ -253,5 +253,5 @@
 
 	if (headerlen == sizeof(ipv4_pseudo_header_t)) {
-		header_in = (ipv4_pseudo_header_t *) header;
+		header_in = (ipv4_pseudo_header_ref) header;
 		header_in->data_length = htons(data_length);
 		return EOK;
Index: uspace/lib/net/il/ip_remote.c
===================================================================
--- uspace/lib/net/il/ip_remote.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/il/ip_remote.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -78,7 +78,7 @@
  * @param[in] me	The requesting module service.
  * @param[in] receiver	The message receiver. Used for remote connection.
- * @return		The phone of the needed service.
- * @return		EOK on success.
- * @return		Other error codes as defined for the bind_service()
+ * @returns		The phone of the needed service.
+ * @returns		EOK on success.
+ * @returns		Other error codes as defined for the bind_service()
  *			function.
  */
@@ -93,5 +93,5 @@
  *
  * @param service	The IP module service. Ignored parameter.
- * @return		The IP module phone on success.
+ * @returns		The IP module phone on success.
  */
 int ip_connect_module(services_t service)
@@ -186,5 +186,5 @@
  */
 int ip_packet_size_req_remote(int ip_phone, device_id_t device_id,
-    packet_dimension_t *packet_dimension)
+    packet_dimension_ref packet_dimension)
 {
 	return generic_packet_size_req_remote(ip_phone, NET_IL_PACKET_SPACE,
@@ -204,5 +204,5 @@
  */
 int ip_received_error_msg_remote(int ip_phone, device_id_t device_id,
-    packet_t *packet, services_t target, services_t error)
+    packet_t packet, services_t target, services_t error)
 {
 	return generic_received_msg_remote(ip_phone, NET_IP_RECEIVED_ERROR,
@@ -225,5 +225,5 @@
  *			function.
  */
-int ip_send_msg_remote(int ip_phone, device_id_t device_id, packet_t *packet,
+int ip_send_msg_remote(int ip_phone, device_id_t device_id, packet_t packet,
     services_t sender, services_t error)
 {
Index: uspace/lib/net/include/adt/module_map.h
===================================================================
--- uspace/lib/net/include/adt/module_map.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/adt/module_map.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -48,4 +48,9 @@
 typedef struct module_struct module_t;
 
+/** Type definition of the module structure pointer.
+ * @see module_struct
+ */
+typedef module_t *module_ref;
+
 /** Module map.
  * Sorted by module names.
@@ -72,7 +77,7 @@
 };
 
-extern int add_module(module_t **, modules_t *, const char *, const char *,
+extern int add_module(module_ref *, modules_ref, const char *, const char *,
     services_t, task_id_t, connect_module_t *);
-extern module_t *get_running_module(modules_t *, char *);
+extern module_ref get_running_module(modules_ref, char *);
 extern task_id_t spawn(const char *);
 
